"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.forceDomain = void 0;
const redirect_1 = require("./redirect");
const forceDomain = function (options) {
    return function (req, res, next) {
        var _a;
        const [protocol] = [(_a = req.headers['x-forwarded-proto']) !== null && _a !== void 0 ? _a : req.protocol].flat();
        const newRoute = redirect_1.redirect(protocol, req.headers.host, req.url, options);
        if (!newRoute) {
            return next();
        }
        const statusCode = newRoute.type === 'temporary' ? 307 : 301;
        res.writeHead(statusCode, {
            Location: newRoute.url
        });
        res.end();
    };
};
exports.forceDomain = forceDomain;
