"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.redirect = void 0;
const rewrite_1 = require("./rewrite");
const redirect = function (protocol, hostHeader, url, options) {
    var _a, _b, _c, _d;
    const hostHeaderParts = (hostHeader !== null && hostHeader !== void 0 ? hostHeader : '').split(':');
    const hostname = (_a = hostHeaderParts[0]) !== null && _a !== void 0 ? _a : '';
    const port = hostHeaderParts[1] ? Number(hostHeaderParts[1]) : undefined;
    const targetProtocol = (_b = options.protocol) !== null && _b !== void 0 ? _b : protocol;
    const isEnabled = (_c = options.isEnabled) !== null && _c !== void 0 ? _c : true;
    if ((hostname === 'localhost' || hostname === '127.0.0.1') ||
        hostname.startsWith('192.168.') || !isEnabled ||
        (hostname === options.hostname && port === options.port && protocol === targetProtocol) ||
        (options.excludeRule && options.excludeRule.test(hostname))) {
        return null;
    }
    const route = `${targetProtocol}://${hostname}${port ? `:${port}` : ''}${url}`;
    const rewrittenRoute = rewrite_1.rewrite(route, options);
    return {
        type: (_d = options.type) !== null && _d !== void 0 ? _d : 'permanent',
        url: rewrittenRoute
    };
};
exports.redirect = redirect;
